package com.zipcodewilmington.phonebook;
import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBookTest {

    @Test
     public void hasEntrytest  ()  {
        PhoneBook info = new PhoneBook();
        String name = "Nuridalia";
        String number= "267-363-8738";
        info.add(name, number);

        //when

    boolean actualOutput= info.hasEntry(name);


        Assert.assertTrue(actualOutput);


    }


    @Test
    public void addEntrytest  ()  {
        PhoneBook info = new PhoneBook();
        String name = "Nuridalia";
        String number= "267-363-8738";
        info.add(name, number);

        //when

        Assert.assertEquals(1, info.getContact().size());


    }
    @Test
    public void getContactTest(){
        PhoneBook info = new PhoneBook();
        String name= "Nuridalia";
        String number= "267-777-9999";
        info.add(name , number);

        String expected= number;
        ArrayList<String> actual= info.getContact(number);
    }



    @Test
    public  void removeTest (){

        PhoneBook info = new PhoneBook();
        String name = "Nuridalia";
        String number = "267-777-9999";
        info.add(name, number);
        info.remove(name);

        boolean actual = info.hasEntry(name);
        boolean expected = true;
        Assert.assertFalse(actual);


    }


    @Test
    public void  reverseLookupTest(){
        PhoneBook info =new PhoneBook();
        String name= "Evangelina";
        String number = "267-999-8888";
        info.add(name, number);

        String actual= info.reverseLookUp(number);
        String expected = name;


        Assert.assertEquals(expected, actual);


    }


    @Test
    public  void listNamesAndNumbers(){
        PhoneBook info = new PhoneBook ();
        info.add("Eva", "999-999-999");
        info.add("nury", "888-999-8787");
        info. add ("Dayhani", "888-777-9090");

        String actual= info.listNameAndNumbers();
        String expected= "Dayhani 888-777-9090\nEva 999-999-999\nnury 888-999-8787\n";

        Assert.assertEquals(expected,actual);




    }
}
